Subject: Re: sctp server

From: Randall Stewart <[email-masked]>
Date: Sun, 20 Oct 2002 13:05:01 -0500

Ram:

The peel off test code is written for BSD NOT linux.. I have
no idea what include files need to be around for lksctp.. besides
which it appears LK must have other problems if it does not
have the basic SCTP_ASOC_CHANGE defines in place... this is
basic socket-api stuff.

R

Ram Avtar Meena wrote:
> Hi,
>  Thanks for your guidance. I downloaded the peel off server/client from
> www.sctp.org but as i found some problem in compiling both the files even
> after installing Sctp prototype and socket API implementation from
> www.sctp.de i recomplied the kernel with lksctp implementation ,but still
> getting the same error (iam posting initial part of error at the end).
> It is surprising to know that the new kernel passed all sctp related test
> given in http://lksctp.sourceforge.net .
> 
> lsctp-2_5_41-0_6_0I complied lksctp-2_5_29-0_5_0 with linux-2.5.29.tar.gz
> kernel.
> 
> 
> <--error -->
> 
> [rambo@ChillSpirit peel]$ gcc peel_server.c
> peel_server.c:11:26: net/if_types.h: No such file or directory
> peel_server.c:12:23: net/if_dl.h: No such file or directory
> peel_server.c:26:26: netinet/sctp.h: No such file or directory
> peel_server.c:27:30: netinet/sctp_uio.h: No such file or directory
> peel_server.c:28:36: netinet/sctp_constants.h: No such file or directory
> peel_server.c: In function `my_handle_notification':
> peel_server.c:239: dereferencing pointer to incomplete type
> peel_server.c:240: `SCTP_ASSOC_CHANGE' undeclared (first use in this
> function)
> peel_server.c:240: (Each undeclared identifier is reported only once
> peel_server.c:240: for each function it appears in.)
> peel_server.c:241: dereferencing pointer to incomplete type
> peel_server.c:242: dereferencing pointer to incomplete type
> peel_server.c:244: `SCTP_COMM_UP' undeclared (first use in this function)
> peel_server.c:248: `SCTP_COMM_LOST' undeclared (first use in this
> function)
> . . .
> . . .
> . . .
> 
> <--end-->
> 
> Errors related to sctp.h and sctp_sonstants.h in line 26 and 28 can be
> removed my placing the files in appropriate place but there is no
> netinet/sctp_uio.h file.
> 
> I really wants to contribute to this field but iam very sorry to say that
> there is not much information either on internet or otherwise. And that's
> one more reason that i appreciate your guidance and suggestions.
> 
> With regards,
> 
> Ram
> 
> 
> 
> On Wed, 9 Oct 2002, Randall Stewart wrote:
> 
> 
>>Ram Avtar Meena wrote:
>>
>>>Hi,
>>>  I am a 4th year student of computer science and engineering and as my
>>>networks project i am asked to work on sctp server/client
>>>implemetation,Although i have knowledge of tcp/ip server/client
>>>programming but still i can't understand much of sctp. I have already
>>>tried looking for materials on this part but could not get it, and its rfc
>>>2960 also don't have much on server/client programming over sctp.
>>>I read your post on sctp.org and i hope you could guide me on this one.
>>>Please consider my request.
>>>
>>>thanks
>>>
>>
>>Ram:
>>
>>If you go to the download page of
>>http://www.sctp.org
>>
>>You will find a new "peel off" server and client.
>>This is a small tarball that should give you a good
>>idea about how to use SCTP in a sockets api.
>>
>>You also need to take a look at the sockets api draft
>>on the ietf web page... there is a pointer to this from
>>the "RFC's and internet drafts page'
>>
>>
> 
> 
> 
> 
> 
> 
> 
> 

-- 
Randall R. Stewart
[email-masked] 815-342-5222 (cell phone)

---

From: Jon Grimm <[email-masked]>
Date: Mon, 21 Oct 2002 08:06:00 -0500

Ram,
	I'm forwarding your note over to lksctp-developers as this is an lksctp
question.   If you have lksctp related questions you'll have better luck
finding help there:   <[email-masked]>

The short answer is that you are using the BSD header files. ;-)

> > peel_server.c:28:36: netinet/sctp_constants.h: No such file or directory

The long answer is that I'm not sure if this program is ported over to
lksctp.
I know Sridhar had been playing with it one afternoon, so it may be done
and I just don't know it.  Minimally, the lksctp-tools package includes
the 
netinet/sctp.h file you'll need for compilation.  

Best Regards,
Jon Grimm

---

From: "Randall Stewart (cisco)" <[email-masked]>
Date: Mon, 21 Oct 2002 10:00:07 -0500

Jon:

If anyone cares to send me patches for lk-sctp (ifdef's around header 
files etc) I will
be more than glad to make sure the code is updated..

R

-- 
Randall R. Stewart
ITD
Cisco Systems Inc.
[email-masked] 815-342-5222(cell) or 815-477-2127(office)